# Direct Upload ## Upload videos via direct upload URLs `client.stream.directUpload.create(DirectUploadCreateParamsparams, RequestOptionsoptions?): DirectUploadCreateResponse` **post** `/accounts/{account_id}/stream/direct_upload` Creates a direct upload that allows video uploads without an API key. ### Parameters - `params: DirectUploadCreateParams` - `account_id: string` Path param: The account identifier tag. - `maxDurationSeconds: number` Body param: The maximum duration in seconds for a video upload. Can be set for a video that is not yet uploaded to limit its duration. Uploads that exceed the specified duration will fail during processing. A value of `-1` means the value is unknown. - `allowedOrigins?: Array` Body param: Lists the origins allowed to display the video. Enter allowed origin domains in an array and use `*` for wildcard subdomains. Empty arrays allow the video to be viewed on any origin. - `creator?: string` Body param: A user-defined identifier for the media creator. - `expiry?: string` Body param: The date and time after upload when videos will not be accepted. - `meta?: unknown` Body param: A user modifiable key-value store used to reference other systems of record for managing videos. - `requireSignedURLs?: boolean` Body param: Indicates whether the video can be a accessed using the UID. When set to `true`, a signed token must be generated with a signing key to view the video. - `scheduledDeletion?: string` Body param: Indicates the date and time at which the video will be deleted. Omit the field to indicate no change, or include with a `null` value to remove an existing scheduled deletion. If specified, must be at least 30 days from upload time. - `thumbnailTimestampPct?: number` Body param: The timestamp for a thumbnail image calculated as a percentage value of the video's duration. To convert from a second-wise timestamp to a percentage, divide the desired timestamp by the total duration of the video. If this value is not set, the default thumbnail image is taken from 0s of the video. - `watermark?: Watermark` Body param - `uid?: string` The unique identifier for the watermark profile. - `uploadCreator?: string` Header param: A user-defined identifier for the media creator. ### Returns - `DirectUploadCreateResponse` - `scheduledDeletion?: string` Indicates the date and time at which the video will be deleted. Omit the field to indicate no change, or include with a `null` value to remove an existing scheduled deletion. If specified, must be at least 30 days from upload time. - `uid?: string` A Cloudflare-generated unique identifier for a media item. - `uploadURL?: string` The URL an unauthenticated upload can use for a single `HTTP POST multipart/form-data` request. - `watermark?: Watermark` - `created?: string` The date and a time a watermark profile was created. - `downloadedFrom?: string` The source URL for a downloaded image. If the watermark profile was created via direct upload, this field is null. - `height?: number` The height of the image in pixels. - `name?: string` A short description of the watermark profile. - `opacity?: number` The translucency of the image. A value of `0.0` makes the image completely transparent, and `1.0` makes the image completely opaque. Note that if the image is already semi-transparent, setting this to `1.0` will not make the image completely opaque. - `padding?: number` The whitespace between the adjacent edges (determined by position) of the video and the image. `0.0` indicates no padding, and `1.0` indicates a fully padded video width or length, as determined by the algorithm. - `position?: string` The location of the image. Valid positions are: `upperRight`, `upperLeft`, `lowerLeft`, `lowerRight`, and `center`. Note that `center` ignores the `padding` parameter. - `scale?: number` The size of the image relative to the overall size of the video. This parameter will adapt to horizontal and vertical videos automatically. `0.0` indicates no scaling (use the size of the image as-is), and `1.0`fills the entire video. - `size?: number` The size of the image in bytes. - `uid?: string` The unique identifier for a watermark profile. - `width?: number` The width of the image in pixels. ### Example ```node import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const directUpload = await client.stream.directUpload.create({ account_id: '023e105f4ecef8ad9ca31a8372d0c353', maxDurationSeconds: 1, }); console.log(directUpload.uid); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "scheduledDeletion": "2014-01-02T02:20:00Z", "uid": "ea95132c15732412d22c1476fa83f27a", "uploadURL": "www.example.com/samplepath", "watermark": { "created": "2014-01-02T02:20:00Z", "downloadedFrom": "https://company.com/logo.png", "height": 0, "name": "Marketing Videos", "opacity": 0.75, "padding": 0.1, "position": "center", "scale": 0.1, "size": 29472, "uid": "ea95132c15732412d22c1476fa83f27a", "width": 0 } } } ``` ## Domain Types ### Direct Upload Create Response - `DirectUploadCreateResponse` - `scheduledDeletion?: string` Indicates the date and time at which the video will be deleted. Omit the field to indicate no change, or include with a `null` value to remove an existing scheduled deletion. If specified, must be at least 30 days from upload time. - `uid?: string` A Cloudflare-generated unique identifier for a media item. - `uploadURL?: string` The URL an unauthenticated upload can use for a single `HTTP POST multipart/form-data` request. - `watermark?: Watermark` - `created?: string` The date and a time a watermark profile was created. - `downloadedFrom?: string` The source URL for a downloaded image. If the watermark profile was created via direct upload, this field is null. - `height?: number` The height of the image in pixels. - `name?: string` A short description of the watermark profile. - `opacity?: number` The translucency of the image. A value of `0.0` makes the image completely transparent, and `1.0` makes the image completely opaque. Note that if the image is already semi-transparent, setting this to `1.0` will not make the image completely opaque. - `padding?: number` The whitespace between the adjacent edges (determined by position) of the video and the image. `0.0` indicates no padding, and `1.0` indicates a fully padded video width or length, as determined by the algorithm. - `position?: string` The location of the image. Valid positions are: `upperRight`, `upperLeft`, `lowerLeft`, `lowerRight`, and `center`. Note that `center` ignores the `padding` parameter. - `scale?: number` The size of the image relative to the overall size of the video. This parameter will adapt to horizontal and vertical videos automatically. `0.0` indicates no scaling (use the size of the image as-is), and `1.0`fills the entire video. - `size?: number` The size of the image in bytes. - `uid?: string` The unique identifier for a watermark profile. - `width?: number` The width of the image in pixels.